package com.engine.jclproduct.entity.vo;

import com.cloudstore.eccom.pc.table.WeaTableType;
import com.engine.jclproduct.annotation.WeaverTable;
import com.engine.jclproduct.annotation.WeaverTableColumn;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @Author liang.cheng
 * @Date 2024/10/25 2:22 PM
 * @Description:
 * @Version 1.0
 */

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@WeaverTable(pageId = "6f201832-a940-4225-a4c9-3f4b96ff5b89",
        fields = "t.id," +
                "t.userId," +
                "t.workcode," +
                "t.employeeStatus," +
                "t.subCompanyId," +
                "t.departmentId," +
                "t.position," +
                "t.superior," +
                "t.companyStartDate," +
                "t.workyear," +
                "t.sex," +
                "t.birthday",
        fromSql = "FROM uf_EmploymentRecord t",
        orderby = "userid",
        sortway = "asc",
        primarykey = "id",
        tableType = WeaTableType.CHECKBOX
)
public class TimeResourceVo {

    /**
     * 主键
     */
    @WeaverTableColumn(column = "id",text = "序号", display = false)
    private Integer id;

    /**
     * 姓名
     */
    @WeaverTableColumn( text = "姓名", width = "10%", column = "userId", transmethod = "")
    private String userId;
    /**
     * 工号
     */
    @WeaverTableColumn( text = "工号", width = "10%", column = "workcode", transmethod = "")
    private String workcode;
    /**
     * 状态
     */
    @WeaverTableColumn( text = "状态", width = "10%", column = "employeeStatus")
    private String employeeStatus;

    /**
     * 分部
     */
    @WeaverTableColumn( text = "分部", width = "10%", column = "subCompanyId", transmethod = "")
    private String subCompanyId;
    /**
     * 部门
     */
    @WeaverTableColumn( text = "部门", width = "10%", column = "departmentId", transmethod = "")
    private String departmentId;
    /**
     * 岗位
     */
    @WeaverTableColumn( text = "岗位", width = "10%", column = "position", transmethod = "")
    private String position;
    /**
     * 直接上级
     */
    @WeaverTableColumn( text = "直接上级", width = "10%", column = "superior")
    private Integer superior;
    /**
     * 入职日期
     */
    @WeaverTableColumn( text = "入职日期", width = "10%", column = "companyStartDate")
    private Integer companyStartDate;
    /**
     * 司龄
     */
    @WeaverTableColumn( text = "司龄", width = "10%", column = "workyear")
    private Integer workyear;
    /**
     * 性别
     */
    @WeaverTableColumn( text = "性别", width = "20%", column = "sex", transmethod = "")
    private String sex;
    /**
     * 生日
     */
    @WeaverTableColumn( text = "生日", width = "10%", column = "birthday")
    private String birthday;




}
