package com.engine.jclproduct.utils;

import com.engine.jclproduct.entity.po.EmploymentRecordPo;
import com.engine.jclproduct.entity.po.HrmresourcePo;
import com.weaver.general.Util;
import weaver.common.DateUtil;
import weaver.conn.RecordSet;

import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Author liang.cheng
 * @Date 2024/10/23 10:14 AM
 * @Description: TODO
 * @Version 1.0
 */
public class EmploymentUtil {


    /**
     * 变动类型
     * @return
     */
    public static  Integer getChangeType(Integer status){

        Integer changeType = null;

        switch (status){
            case 0: case 2: case 3:
                changeType = 0;
                break;
            case 1:
                changeType = 1;
                break;
            case 4: case 5: case 6: case 7:
                changeType = 3;
                break;
            default:
                break;
        }
        return changeType;
    }


    /**
     * 年月日
     * @param companysDate
     * @return
     */
    public static Map<String,Integer> dateSplitExample(String companysDate){

        if ("".equals(companysDate)) {
            companysDate = DateUtil.getCurrentDate();
        }
        LocalDate date = LocalDate.parse(companysDate);
        return new HashMap<String,Integer>(4){
            {
                put("year",date.getYear());
                put("month",date.getMonthValue());
                put("day",date.getDayOfMonth());
            }
        };
    }

    /**
     * 获取当前人员表人员信息
     * @return
     */
    public static List<HrmresourcePo> getHrmResources(){
        List<HrmresourcePo> hrmresourcePoList = new ArrayList<>();
        RecordSet rs = new RecordSet();
        rs.executeQuery("select id,workcode,status,companystartdate,companyworkyear,sex,birthday,jobtitle,departmentid,subcompanyid1,managerid from hrmresource");
        while (rs.next()) {
            hrmresourcePoList.add(HrmresourcePo.builder()
                    .userId(Util.getIntValue(rs.getString("id")))
                    .workcode(Util.null2String(rs.getString("workcode")))
                    .status(Util.getIntValue(rs.getString("status")))
                    .companyStartDate(Util.null2String(rs.getString("companystartdate")))
                    .companyWorkyear("".equals(Util.null2String(rs.getString("companyworkyear"))) ? "0.00" : Util.null2String(rs.getString("companyworkyear")))
                    .sex(Util.getIntValue(rs.getString("sex")))
                    .birthday(Util.null2String(rs.getString("birthday")))
                    .jobTitle(Util.getIntValue(rs.getString("jobtitle")))
                    .departmentId(Util.getIntValue(rs.getString("departmentid")))
                    .subcompanyId(Util.getIntValue(rs.getString("subcompanyid1")))
                    .managerId(Util.getIntValue(rs.getString("managerid")))
                    .build());
        }

        return hrmresourcePoList;
    }


    /**
     * 任职记录 各种状态下 相关变动日期记录
     * @param recordPo
     */
    public static void dutyStatusDate(EmploymentRecordPo recordPo) {
        String currentDate = DateUtil.getCurrentDate();
        switch (recordPo.getEmployeeStatus()){
            case 0:
                recordPo.setProbationStartDate(currentDate);
                break;
            case 1:
                recordPo.setRegularizationDate(currentDate);
                break;
            case 4: case 5:
                recordPo.setLastWorkDate(currentDate);
                break;
            case 7:
                recordPo.setExpectedLastWorkDate(currentDate);
                break;
            default:
                break;
        }

    }

    /**
     * 日期字符串 与当前日期比较
     * @param dateStr1
     * @return
     */
    public static boolean compareDate(String dateStr1){
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
        boolean result = false;
        try {
            LocalDate inputDate = LocalDate.parse(dateStr1, formatter);

            LocalDate today = LocalDate.now();

            // 判断当前日期是否大于传入的日期
            if (today.isAfter(inputDate)) {
                result = true;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return result;
    }


}
